## r-cran-nloptr 1.0.4

=== DESCRIPTION ===
Package: nloptr
Type: Package
Title: R interface to NLopt
Version: 1.0.4
Date: 2014-08-02
Author: Jelmer Ypma <uctpjyy@ucl.ac.uk>, with contributions by
        Hans W. Borchers <hwborchers@googlemail.com> and 
        Dirk Eddelbuettel <edd@debian.org>
Maintainer: Jelmer Ypma <uctpjyy@ucl.ac.uk>
Description: 
    nloptr is an R interface to NLopt. NLopt is a free/open-source library for
    nonlinear optimization, providing a common interface for a number of
    different free optimization routines available online as well as original
    implementations of various other algorithms.
    See http://ab-initio.mit.edu/wiki/index.php/NLopt_Introduction for more
    information on the available algorithms. During installation on Unix the
    NLopt code is downloaded and compiled from the NLopt website.
License: LGPL-3
Suggests: testthat (>= 0.8.1)
LazyLoad: yes
Packaged: 2014-08-02 18:12:19 UTC; Jelmer
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2014-08-04 15:35:43

=== debian/changelog ===
r-cran-nloptr (1.0.4-1) unstable; urgency=low

  * New upstream release
  
  * debian/patches/series: Disable previous as upstream integrated our
    contributed configure{,.ac} and related changes

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 04 Aug 2014 17:26:10 -0500

r-cran-nloptr (1.0.0-1) unstable; urgency=low

  * Initial Debian release 				(Closes: #753852)

  * src/Makevars:  Simplified to use the Debian library package for nlopt
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 05 Jul 2014 12:36:21 -0500

=== debian/rules ===
#!/usr/bin/make -f
# 							-*- makefile -*-
# debian/rules file for the Debian/GNU Linux r-cran-nloptr package
# Copyright 2003-2014 by Dirk Eddelbuettel <edd@debian.org>

include /usr/share/R/debian/r-cran.mk

=== debian/watch ===
version=3
http://cran.r-project.org/src/contrib/nloptr_([-\d\.]*)\.tar.gz

## r-cran-nloptr 1.2.1

=== debian/changelog ===
r-cran-nloptr (1.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 05 Oct 2018 22:21:50 -0500

r-cran-nloptr (1.2.0-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Set Build-Depends: to current R version
  * debian/control: Set Build-Depends: to 'debhelper (>= 10)'
  * debian/control: Set Standards-Version: to current version 
  * debian/control: Add Vcs-Browser: and Vcs-Git:
  * debian/compat: Increase level to 10
  * debian/control: Switch from cdbs to dh-r
  * debian/rules: Idem

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 05 Oct 2018 21:49:37 -0500

=== debian/control ===
Source: r-cran-nloptr
Section: gnu-r
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: debhelper (>= 10), r-base-dev (>= 3.5.1), dh-r, libnlopt-dev, pkg-config
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git
Homepage: https://cran.r-project.org/package=nloptr

Package: r-cran-nloptr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${R:Depends}
Description: GNU R package for interface to NLopt
 The nloptr package provides an R interface to NLopt. NLopt is a
 free/open-source library for nonlinear optimization, providing a
 common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms.  See
 http://ab-initio.mit.edu/wiki/index.php/NLopt_Introduction for more
 information on the available algorithms.

## r-cran-nloptr 1.2.2.2

=== DESCRIPTION ===
Package: nloptr
Type: Package
Title: R Interface to NLopt
Version: 1.2.2.2
Date: 2020-07-02
Authors@R: c(person("Jelmer", "Ypma", role = c("aut", "cre"),
                    email = "uctpjyy@ucl.ac.uk"),
             person(c("Steven", "G."), "Johnson", role = "aut",
                    comment = "author of the NLopt C library"),
             person(c("Hans", "W."), "Borchers", role = "ctb",
                    email = "hwborchers@googlemail.com"),
             person("Dirk", "Eddelbuettel", role = "ctb",
                    email = "edd@debian.org"),
             person("Brian", "Ripley", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Kurt", "Hornik", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Julien", "Chiquet", role = "ctb"),
             person(given = "Avraham", family = "Adler", 
                    role = "ctb", email="Avraham.Adler@gmail.com",
                    comment = c("removal deprecated calls from tests",
                      ORCID = "0000-0002-3039-0703")))
Description: 
    Solve optimization problems using an R interface to NLopt. NLopt is a 
    free/open-source library for nonlinear optimization, providing a common
    interface for a number of different free optimization routines available
    online as well as original implementations of various other algorithms.
    See <http://ab-initio.mit.edu/wiki/index.php/NLopt_Introduction> for more
    information on the available algorithms. During installation of nloptr on 
    Unix-based systems, the installer checks whether the NLopt library is
    installed on the system. If the NLopt library cannot be found, the code
    is compiled using the NLopt source included in the nloptr package.
SystemRequirements: A system installation of NLopt >= 2.4.0 (with
        headers) will be used if available.
License: LGPL-3
Suggests: testthat (>= 0.8.1), knitr, rmarkdown, inline (>= 0.3.14)
LazyLoad: yes
NeedsCompilation: yes
VignetteBuilder: knitr
RoxygenNote: 6.1.0
Packaged: 2020-07-02 17:30:38 UTC; ripley
Author: Jelmer Ypma [aut, cre],
  Steven G. Johnson [aut] (author of the NLopt C library),
  Hans W. Borchers [ctb],
  Dirk Eddelbuettel [ctb],
  Brian Ripley [ctb] (build process on multiple OS),
  Kurt Hornik [ctb] (build process on multiple OS),
  Julien Chiquet [ctb],
  Avraham Adler [ctb] (removal deprecated calls from tests,
    <https://orcid.org/0000-0002-3039-0703>)
Maintainer: Jelmer Ypma <uctpjyy@ucl.ac.uk>
Repository: CRAN
Date/Publication: 2020-07-02 17:32:14 UTC

=== debian/changelog ===
r-cran-nloptr (1.2.2.2-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Build-Depends: to current R version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 06 Jul 2020 08:28:53 -0500

r-cran-nloptr (1.2.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 14 Mar 2020 09:34:08 -0500

r-cran-nloptr (1.2.2-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Build-Depends: to current R version
  * debian/control: Set Standards-Version: to current version 

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 05 Mar 2020 13:53:50 -0600

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper (>= 10), r-base-dev (>= 3.5.1), dh-r, libnlopt-dev, pkg-config
-Standards-Version: 4.2.1
+Build-Depends: debhelper (>= 10), r-base-dev (>= 4.0.2), dh-r, libnlopt-dev, pkg-config
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
 Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git
 Homepage: https://cran.r-project.org/package=nloptr

=== debian/rules ===
#!/usr/bin/make -f
# 							-*- makefile -*-
# debian/rules file for the Debian/GNU Linux r-cran-nloptr package
# Copyright 2003 - 2018 by Dirk Eddelbuettel <edd@debian.org>

%:
	dh $@ --buildsystem R

## r-cran-nloptr 1.2.2.3

=== debian/changelog ===
r-cran-nloptr (1.2.2.3-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Build-Depends: to current R version
  * debian/control: Set Standards-Version: to current version  
  * debian/control: Switch to virtual debhelper-compat (= 11)
  * debian/compat: Removed

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 05 Nov 2021 12:35:19 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper (>= 10), r-base-dev (>= 4.0.2), dh-r, libnlopt-dev, pkg-config
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.1.2), dh-r, libnlopt-dev, pkg-config
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
 Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git
 Homepage: https://cran.r-project.org/package=nloptr

## r-cran-nloptr 2.0.0

=== debian/changelog ===
r-cran-nloptr (2.0.0-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Add Build-Depends: on r-cran-testthat

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 29 Jan 2022 08:12:02 -0600

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.1.2), dh-r, libnlopt-dev, pkg-config
+Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.1.2), dh-r, libnlopt-dev, pkg-config, r-cran-testthat
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
 Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git

## r-cran-nloptr 2.0.3

=== CMakeLists.txt ===
#==============================================================================
# NLOPT CMake file
#
# NLopt is a free/open-source library for nonlinear optimization, providing
# a common interface for a number of different free optimization routines
# available online as well as original implementations of various other
# algorithms
# WEBSITE: http://ab-initio.mit.edu/wiki/index.php/NLopt
# AUTHOR: Steven G. Johnson
#
# This CMakeLists.txt file was created to compile NLOPT with the CMAKE utility.
# Benoit Scherrer, 2010 CRL, Harvard Medical School
# Copyright (c) 2008-2009 Children's Hospital Boston
#==============================================================================
cmake_minimum_required (VERSION 3.2)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (nlopt)

#==============================================================================
# version
set (NLOPT_MAJOR_VERSION "2")
set (NLOPT_MINOR_VERSION "7")
set (NLOPT_BUGFIX_VERSION "1")
set (NLOPT_VERSION_STRING ${NLOPT_MAJOR_VERSION}.${NLOPT_MINOR_VERSION}.${NLOPT_BUGFIX_VERSION})
message (STATUS "NLopt version ${NLOPT_VERSION_STRING}")

# This is the ABI version number, which differes from the API version above
# (it indicates ABI compatibility), but they are typically incremented together.
set(SO_MAJOR 0)
set(SO_MINOR 11)
set(SO_PATCH 1)
#==============================================================================

list (APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

option (NLOPT_CXX "enable cxx routines" ON)
option (NLOPT_FORTRAN "enable fortran tests" OFF)
option (BUILD_SHARED_LIBS "Build NLopt as a shared library" ON)
option (NLOPT_PYTHON "build python bindings" ON)
option (NLOPT_OCTAVE "build octave bindings" ON)
option (NLOPT_MATLAB "build matlab bindings" ON)
option (NLOPT_GUILE "build guile bindings" ON)
option (NLOPT_SWIG "use SWIG to build bindings" ON)

if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option (NLOPT_TESTS "build unit tests" ON)
else ()
  option (NLOPT_TESTS "build unit tests" OFF)
endif ()

if (NLOPT_FORTRAN)
  enable_language (Fortran)
endif ()

include (GNUInstallDirs)

# Offer the user the choice of overriding the installation directories
set (INSTALL_LIB_DIR     ${CMAKE_INSTALL_LIBDIR}        CACHE PATH "Installation directory for libraries")
set (INSTALL_BIN_DIR     ${CMAKE_INSTALL_BINDIR}        CACHE PATH "Installation directory for executables")
set (INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}    CACHE PATH "Installation directory for header files")
set (INSTALL_DATA_DIR    ${CMAKE_INSTALL_DATADIR}/nlopt CACHE PATH "Installation directory for data files")
set (INSTALL_MAN_DIR     ${CMAKE_INSTALL_MANDIR}        CACHE PATH "Installation directory for man documentation")
set (INSTALL_CMAKE_DIR   ${INSTALL_LIB_DIR}/cmake/nlopt CACHE PATH "Installation directory for cmake config files")

# Make relative paths absolute (needed later on)
foreach (p LIB BIN INCLUDE DATA CMAKE)
  set (var INSTALL_${p}_DIR)
  set (RELATIVE_INSTALL_${p}_DIR ${INSTALL_${p}_DIR})
  if (NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif ()
endforeach ()


set (CMAKE_INSTALL_RPATH ${INSTALL_LIB_DIR})
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
if(POLICY CMP0042)
  # Set MACOSX_RPATH to ON
  cmake_policy(SET CMP0042 NEW)
endif()
if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif ()

include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckTypeSize)
include (CheckCCompilerFlag)
include (CheckCXXSymbolExists)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

#==============================================================================
# COMPILATION CHECKINGS and CONFIGURATION GENERATION
#==============================================================================
check_include_file (getopt.h HAVE_GETOPT_H)
check_include_file (unistd.h HAVE_UNISTD_H)
check_include_file (stdint.h HAVE_STDINT_H)
check_include_file (time.h HAVE_TIME_H)
check_include_file (sys/time.h HAVE_SYS_TIME_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()
check_function_exists (getpid HAVE_GETPID)
check_function_exists (syscall HAVE_GETTID_SYSCALL)
check_function_exists (isinf HAVE_ISINF)
check_function_exists (isnan HAVE_ISNAN)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (qsort_r HAVE_QSORT_R)
check_function_exists (time HAVE_TIME)
check_function_exists (copysign HAVE_COPYSIGN)
check_function_exists (getopt HAVE_GETOPT)
check_type_size ("uint32_t" SIZEOF_UINT32_T)
set (HAVE_UINT32_T ${SIZEOF_UINT32_T})
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)

check_library_exists ("m" sqrt "" HAVE_LIBM)
if (HAVE_LIBM)
  set (M_LIBRARY m)
endif()

if (NOT DEFINED HAVE_FPCLASSIFY)
  message(STATUS "Looking for fpclassify")
  file (WRITE ${PROJECT_BINARY_DIR}/fpclassify.c "#include <math.h>\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "int main(void) {\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "if (!fpclassify(3.14159)) fpclassify(2.7183);\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "  return 0; }\n")
  try_compile (HAVE_FPCLASSIFY
  ${PROJECT_BINARY_DIR}/build_fpclassify
  ${PROJECT_BINARY_DIR}/fpclassify.c
  CMAKE_FLAGS -DLINK_LIBRARIES=m)
  message(STATUS "Looking for fpclassify - ${HAVE_FPCLASSIFY}")
endif ()

option (WITH_THREADLOCAL "check thread local keyword" ON)
if (WITH_THREADLOCAL AND NOT DEFINED THREADLOCAL)
  foreach (_THREADLOCAL_KEY "__thread" "__declspec(thread)")
    unset (HAVE_THREAD_LOCAL_STORAGE CACHE)
    check_c_source_compiles("
    ${_THREADLOCAL_KEY} int tls;

    int main(void) {
        return 0;
    }" HAVE_THREAD_LOCAL_STORAGE)
    if (HAVE_THREAD_LOCAL_STORAGE)
      set (THREADLOCAL ${_THREADLOCAL_KEY} CACHE STRING "Thread local keyword")
    endif ()
  endforeach()
endif ()


if (NLOPT_CXX OR NLOPT_PYTHON OR NLOPT_GUILE OR NLOPT_OCTAVE)
  check_cxx_symbol_exists (__cplusplus ciso646 SYSTEM_HAS_CXX)
  if (SYSTEM_HAS_CXX)
    check_cxx_compiler_flag ("-std=c++11" SUPPORTS_STDCXX11)
    if (SUPPORTS_STDCXX11)
      set (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
      if (NLOPT_CXX)
        set (NLOPT_CXX11 ON)
      endif ()
    endif ()
  else()
    message (FATAL_ERROR "The compiler doesn't support CXX.")
  endif ()
endif ()

#==============================================================================
# CREATE nlopt_config.h
#==============================================================================

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt_config.h IMMEDIATE)

# pkgconfig file
if (UNIX OR MINGW)
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt.pc.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc @ONLY)
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc DESTINATION ${RELATIVE_INSTALL_LIB_DIR}/pkgconfig)
endif ()

#==============================================================================
# nlopt LIBRARY TARGET (SHARED OR STATIC)
#==============================================================================

set (NLOPT_HEADERS
  src/api/nlopt.h ${PROJECT_BINARY_DIR}/nlopt.hpp ${PROJECT_BINARY_DIR}/nlopt.f
)

add_custom_command (OUTPUT nlopt.hpp
  COMMAND ${CMAKE_COMMAND} -DAPI_SOURCE_DIR=${PROJECT_SOURCE_DIR}/src/api -P ${PROJECT_SOURCE_DIR}/cmake/generate-cpp.cmake
  MAIN_DEPENDENCY src/api/nlopt-in.hpp)
add_custom_target (generate-cpp ALL DEPENDS nlopt.hpp)

add_custom_command (OUTPUT nlopt.f
  COMMAND ${CMAKE_COMMAND} -DAPI_SOURCE_DIR=${PROJECT_SOURCE_DIR}/src/api -P ${PROJECT_SOURCE_DIR}/cmake/generate-fortran.cmake
  MAIN_DEPENDENCY src/api/nlopt.h)
add_custom_target (generate-fortran ALL DEPENDS nlopt.f)

set (NLOPT_SOURCES
  src/algs/direct/DIRect.c src/algs/direct/direct_wrap.c src/algs/direct/DIRserial.c src/algs/direct/DIRsubrout.c src/algs/direct/direct-internal.h src/algs/direct/direct.h
  src/algs/cdirect/cdirect.c src/algs/cdirect/hybrid.c src/algs/cdirect/cdirect.h
  src/algs/praxis/praxis.c src/algs/praxis/praxis.h
  src/algs/luksan/plis.c src/algs/luksan/plip.c src/algs/luksan/pnet.c src/algs/luksan/mssubs.c src/algs/luksan/pssubs.c src/algs/luksan/luksan.h
  src/algs/crs/crs.c src/algs/crs/crs.h
  src/algs/mlsl/mlsl.c src/algs/mlsl/mlsl.h
  src/algs/mma/mma.c src/algs/mma/mma.h src/algs/mma/ccsa_quadratic.c
  src/algs/cobyla/cobyla.c src/algs/cobyla/cobyla.h
  src/algs/newuoa/newuoa.c src/algs/newuoa/newuoa.h
  src/algs/neldermead/nldrmd.c src/algs/neldermead/neldermead.h src/algs/neldermead/sbplx.c
  src/algs/auglag/auglag.c src/algs/auglag/auglag.h
  src/algs/bobyqa/bobyqa.c src/algs/bobyqa/bobyqa.h
  src/algs/isres/isres.c src/algs/isres/isres.h
  src/algs/slsqp/slsqp.c src/algs/slsqp/slsqp.h
  src/algs/esch/esch.c src/algs/esch/esch.h
  src/api/general.c src/api/options.c src/api/optimize.c src/api/deprecated.c src/api/nlopt-internal.h src/api/nlopt.h src/api/f77api.c src/api/f77funcs.h src/api/f77funcs_.h ${PROJECT_BINARY_DIR}/nlopt.hpp
  src/util/mt19937ar.c src/util/sobolseq.c src/util/soboldata.h src/util/timer.c src/util/stop.c src/util/nlopt-util.h src/util/redblack.c src/util/redblack.h src/util/qsort_r.c src/util/rescale.c
)

if (NLOPT_CXX)
  list (APPEND NLOPT_SOURCES src/algs/stogo/global.cc src/algs/stogo/linalg.cc src/algs/stogo/local.cc src/algs/stogo/stogo.cc src/algs/stogo/tools.cc
        src/algs/stogo/global.h src/algs/stogo/linalg.h src/algs/stogo/local.h src/algs/stogo/stogo_config.h src/algs/stogo/stogo.h src/algs/stogo/tools.h)
endif ()
if (NLOPT_CXX11)
  list (APPEND NLOPT_SOURCES src/algs/ags/data_types.hpp src/algs/ags/evolvent.hpp src/algs/ags/evolvent.cc src/algs/ags/solver.hpp src/algs/ags/solver.cc
  src/algs/ags/local_optimizer.hpp src/algs/ags/local_optimizer.cc src/algs/ags/ags.h src/algs/ags/ags.cc)
endif ()

set_source_files_properties(${NLOPT_SOURCES} PROPERTIES COMPILE_FLAGS "-Wno-array-bounds -Wno-stringop-overflow -Wno-unknown-warning-option")

install (FILES ${NLOPT_HEADERS} DESTINATION ${RELATIVE_INSTALL_INCLUDE_DIR})

set (nlopt_lib nlopt)
add_library (${nlopt_lib} ${NLOPT_SOURCES})
add_dependencies(${nlopt_lib} generate-cpp)
target_link_libraries (${nlopt_lib} ${M_LIBRARY})

set_target_properties (${nlopt_lib} PROPERTIES SOVERSION ${SO_MAJOR})
set_target_properties (${nlopt_lib} PROPERTIES VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}")

#==============================================================================
# INCLUDE DIRECTORIES
#==============================================================================
target_include_directories (${nlopt_lib} PRIVATE
  ${PROJECT_BINARY_DIR}/src/api
  ${PROJECT_BINARY_DIR}
  src/algs/stogo
  src/algs/ags
  src/util
  src/algs/direct
  src/algs/cdirect
  src/algs/praxis
  src/algs/luksan
  src/algs/crs
  src/algs/mlsl
  src/algs/mma
  src/algs/cobyla
  src/algs/newuoa
  src/algs/neldermead
  src/algs/auglag
  src/algs/bobyqa
  src/algs/isres
  src/algs/slsqp
  src/algs/esch
  src/api)

get_target_property (NLOPT_PRIVATE_INCLUDE_DIRS ${nlopt_lib} INCLUDE_DIRECTORIES)
target_include_directories (${nlopt_lib} INTERFACE "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/api;${PROJECT_BINARY_DIR}>" "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")

if (BUILD_SHARED_LIBS)
  target_compile_definitions (${nlopt_lib} PUBLIC NLOPT_DLL)
  target_compile_definitions (${nlopt_lib} PRIVATE NLOPT_DLL_EXPORT)
endif ()

# pass -fPIC in case swig module is built with static library
if (NOT BUILD_SHARED_LIBS)
  check_c_compiler_flag (-fPIC HAS_FPIC)
  if (HAS_FPIC)
    set (CMAKE_C_FLAGS "-fPIC ${CMAKE_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "-fPIC ${CMAKE_CXX_FLAGS}")
  endif ()
endif ()

install ( TARGETS ${nlopt_lib}
          EXPORT  NLoptLibraryDepends
          RUNTIME DESTINATION ${RELATIVE_INSTALL_BIN_DIR}
          LIBRARY DESTINATION ${RELATIVE_INSTALL_LIB_DIR}

=== DESCRIPTION ===
Package: nloptr
Type: Package
Title: R Interface to NLopt
Version: 2.0.3
Authors@R: c(person("Jelmer", "Ypma", role = "aut",
                    email = "uctpjyy@ucl.ac.uk"),
             person(c("Steven", "G."), "Johnson", role = "aut",
                    comment = "author of the NLopt C library"),
             person(c("Hans", "W."), "Borchers", role = "ctb",
                    email = "hwborchers@googlemail.com"),
             person("Dirk", "Eddelbuettel", role = "ctb",
                    email = "edd@debian.org"),
             person("Brian", "Ripley", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Kurt", "Hornik", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Julien", "Chiquet", role = "ctb"),
             person("Avraham", "Adler", role = "ctb", 
                    email = "Avraham.Adler@gmail.com",
                    comment = c("removal deprecated calls from tests",
                      ORCID = "0000-0002-3039-0703")),
             person("Xiongtao", "Dai", role = "ctb"), 
             person("Aymeric", "Stamm", role = c("ctb", "cre"), 
                    email = "aymeric.stamm@math.cnrs.fr", 
                    comment = c(ORCID = "0000-0002-8725-3654")),
             person("Jeroen", "Ooms", role = "ctb",
                    email = "jeroen@berkeley.edu"))
Description: 
    Solve optimization problems using an R interface to NLopt. NLopt is a 
    free/open-source library for nonlinear optimization, providing a common
    interface for a number of different free optimization routines available
    online as well as original implementations of various other algorithms.
    See <https://nlopt.readthedocs.io/en/latest/NLopt_Algorithms/> for more
    information on the available algorithms. Building from included sources 
    requires 'CMake'. On Linux and 'macOS', if a suitable system build of 
    NLopt (2.7.0 or later) is found, it is used; otherwise, it is built 
    from included sources via 'CMake'. On Windows, NLopt is obtained through 
    'rwinlib' for 'R <= 4.1.x' or grabbed from the 'Rtools42 toolchain' for 
    'R >= 4.2.0'.
License: LGPL (>= 3)
SystemRequirements: cmake (>= 3.2.0) which is used only on Linux or
        macOS systems when no system build of nlopt (>= 2.7.0) can be
        found.
Biarch: true
Encoding: UTF-8
RoxygenNote: 7.2.0
LinkingTo: testthat
Suggests: knitr, rmarkdown, xml2, testthat (>= 3.0.0), covr
VignetteBuilder: knitr
Config/testthat/edition: 3
URL: https://astamm.github.io/nloptr/index.html,
        https://github.com/astamm/nloptr
BugReports: https://github.com/astamm/nloptr/issues
NeedsCompilation: yes
Packaged: 2022-05-26 14:40:24 UTC; stamm-a
Author: Jelmer Ypma [aut],
  Steven G. Johnson [aut] (author of the NLopt C library),
  Hans W. Borchers [ctb],
  Dirk Eddelbuettel [ctb],
  Brian Ripley [ctb] (build process on multiple OS),
  Kurt Hornik [ctb] (build process on multiple OS),
  Julien Chiquet [ctb],
  Avraham Adler [ctb] (removal deprecated calls from tests,
    <https://orcid.org/0000-0002-3039-0703>),
  Xiongtao Dai [ctb],
  Aymeric Stamm [ctb, cre] (<https://orcid.org/0000-0002-8725-3654>),
  Jeroen Ooms [ctb]
Maintainer: Aymeric Stamm <aymeric.stamm@math.cnrs.fr>
Repository: CRAN
Date/Publication: 2022-05-26 15:40:02 UTC

=== src/swig/CMakeLists.txt ===

if (POLICY CMP0078)
  cmake_policy(SET CMP0078 NEW)
endif ()
include (UseSWIG)
include (TargetLinkLibrariesWithDynamicLookup)

if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt-enum-renames.i)
  file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/nlopt-enum-renames.i "// AUTOMATICALLY GENERATED -- DO NOT EDIT\n")
  file (STRINGS ${PROJECT_SOURCE_DIR}/src/api/nlopt.h NLOPT_H_LINES REGEX "    NLOPT_[A-Z0-9_]+")
  foreach (NLOPT_H_LINE ${NLOPT_H_LINES})
    string (REGEX REPLACE ".*NLOPT_([A-Z0-9_]+).*" "%rename(NLOPT_\\1) nlopt::\\1;\n" ENUM_LINE ${NLOPT_H_LINE})
    file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt-enum-renames.i "${ENUM_LINE}")
  endforeach ()
endif ()

include_directories (${NLOPT_PRIVATE_INCLUDE_DIRS})
set_source_files_properties (nlopt.i PROPERTIES CPLUSPLUS ON)

if (NUMPY_FOUND AND PYTHONLIBS_FOUND)

  set (SWIG_MODULE_nlopt_python_EXTRA_DEPS nlopt-python.i numpy.i generate-cpp)

  # swig_add_module is deprecated
  if (CMAKE_VERSION VERSION_LESS 3.8)
    swig_add_module (nlopt_python python nlopt.i)
  else ()
    swig_add_library (nlopt_python LANGUAGE python SOURCES nlopt.i)
  endif ()

  # UseSWIG generates now standard target names
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set (nlopt_python ${SWIG_MODULE_nlopt_python_REAL_NAME})
  else ()
    set (nlopt_python "nlopt_python")
  endif ()

  target_include_directories (${nlopt_python} PRIVATE ${PYTHON_INCLUDE_DIRS})
  target_include_directories (${nlopt_python} PRIVATE ${NUMPY_INCLUDE_DIRS})

  swig_link_libraries (nlopt_python ${nlopt_lib})
  target_link_libraries_with_dynamic_lookup (${nlopt_python} ${PYTHON_LIBRARIES})

  set_target_properties (${nlopt_python} PROPERTIES OUTPUT_NAME nlopt)
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set_target_properties (${nlopt_python} PROPERTIES PREFIX "_")
  endif ()

  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.py DESTINATION ${INSTALL_PYTHON_DIR})
  install (TARGETS ${nlopt_python} LIBRARY DESTINATION ${INSTALL_PYTHON_DIR})
endif ()


# guile bindings with gcc only ok with swig >= 2.0.10
if (GUILE_FOUND AND (SWIG_VERSION VERSION_GREATER 2.0.9))

  set_source_files_properties (nlopt.i PROPERTIES SWIG_FLAGS "-scmstub")
  set (SWIG_MODULE_nlopt_guile_EXTRA_DEPS nlopt-guile.i generate-cpp)

  # swig_add_module is deprecated
  if (CMAKE_VERSION VERSION_LESS 3.8)
    swig_add_module (nlopt_guile guile nlopt.i)
  else ()
    swig_add_library (nlopt_guile LANGUAGE guile SOURCES nlopt.i)
  endif ()

  # UseSWIG generates now standard target names
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set (nlopt_guile ${SWIG_MODULE_nlopt_guile_REAL_NAME})
  else ()
    set (nlopt_guile "nlopt_guile")
  endif ()

  target_include_directories (${nlopt_guile} PRIVATE ${GUILE_INCLUDE_DIRS})

  swig_link_libraries (nlopt_guile ${nlopt_lib})
  target_link_libraries_with_dynamic_lookup (${nlopt_guile} ${GUILE_LIBRARIES})

  file (RELATIVE_PATH _REL_GUILE_SITE_PATH ${GUILE_ROOT_DIR} ${GUILE_SITE_DIR})
  set (GUILE_SITE_PATH ${_REL_GUILE_SITE_PATH})
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.scm DESTINATION ${GUILE_SITE_PATH})

  file (RELATIVE_PATH _REL_GUILE_EXTENSION_PATH ${GUILE_ROOT_DIR} ${GUILE_EXTENSION_DIR})
  set (GUILE_EXTENSION_PATH ${_REL_GUILE_EXTENSION_PATH})
  install (TARGETS ${nlopt_guile} LIBRARY DESTINATION ${GUILE_EXTENSION_PATH})
endif ()

=== debian/changelog ===
r-cran-nloptr (2.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 29 May 2022 08:58:20 -0500

r-cran-nloptr (2.0.2-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Standards-Version: to current version  

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 20 May 2022 09:05:56 -0500

r-cran-nloptr (2.0.1-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Build-Depends: to current R version

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 03 May 2022 09:23:13 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.1.2), dh-r, libnlopt-dev, pkg-config, r-cran-testthat
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.2.0), dh-r, libnlopt-dev, pkg-config, r-cran-testthat
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
 Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git
 Homepage: https://cran.r-project.org/package=nloptr

## r-cran-nloptr 2.1.1

=== DESCRIPTION ===
Package: nloptr
Type: Package
Title: R Interface to NLopt
Version: 2.1.1
Authors@R: c(person("Jelmer", "Ypma", role = "aut",
                    email = "uctpjyy@ucl.ac.uk"),
             person(c("Steven", "G."), "Johnson", role = "aut",
                    comment = "author of the NLopt C library"),
             person("Aymeric", "Stamm", role = c("ctb", "cre"),
                    email = "aymeric.stamm@cnrs.fr",
                    comment = c(ORCID = "0000-0002-8725-3654")),
             person(c("Hans", "W."), "Borchers", role = "ctb",
                    email = "hwborchers@googlemail.com"),
             person("Dirk", "Eddelbuettel", role = "ctb",
                    email = "edd@debian.org"),
             person("Brian", "Ripley", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Kurt", "Hornik", role = "ctb",
                    comment = "build process on multiple OS"),
             person("Julien", "Chiquet", role = "ctb"),
             person("Avraham", "Adler", role = "ctb", 
                    email = "Avraham.Adler@gmail.com",
                    comment = c(ORCID = "0000-0002-3039-0703")),
             person("Xiongtao", "Dai", role = "ctb"),
             person("Jeroen", "Ooms", role = "ctb",
                    email = "jeroen@berkeley.edu"))
Description: 
    Solve optimization problems using an R interface to NLopt. NLopt is a 
    free/open-source library for nonlinear optimization, providing a common
    interface for a number of different free optimization routines available
    online as well as original implementations of various other algorithms.
    See <https://nlopt.readthedocs.io/en/latest/NLopt_Algorithms/> for more
    information on the available algorithms. Building from included sources 
    requires 'CMake'. On Linux and 'macOS', if a suitable system build of 
    NLopt (2.7.0 or later) is found, it is used; otherwise, it is built 
    from included sources via 'CMake'. On Windows, NLopt is obtained through 
    'rwinlib' for 'R <= 4.1.x' or grabbed from the appropriate toolchain for
    'R >= 4.2.0'.
License: LGPL (>= 3)
SystemRequirements: cmake (>= 3.2.0) which is used only on Linux or
        macOS systems when no system build of nlopt (>= 2.7.0) can be
        found.
Biarch: true
Encoding: UTF-8
RoxygenNote: 7.3.1
Suggests: knitr, rmarkdown, covr, tinytest
VignetteBuilder: knitr
URL: https://github.com/astamm/nloptr, https://astamm.github.io/nloptr/
BugReports: https://github.com/astamm/nloptr/issues
NeedsCompilation: yes
Packaged: 2024-06-24 15:47:10 UTC; stamm-a
Author: Jelmer Ypma [aut],
  Steven G. Johnson [aut] (author of the NLopt C library),
  Aymeric Stamm [ctb, cre] (<https://orcid.org/0000-0002-8725-3654>),
  Hans W. Borchers [ctb],
  Dirk Eddelbuettel [ctb],
  Brian Ripley [ctb] (build process on multiple OS),
  Kurt Hornik [ctb] (build process on multiple OS),
  Julien Chiquet [ctb],
  Avraham Adler [ctb] (<https://orcid.org/0000-0002-3039-0703>),
  Xiongtao Dai [ctb],
  Jeroen Ooms [ctb]
Maintainer: Aymeric Stamm <aymeric.stamm@cnrs.fr>
Repository: CRAN
Date/Publication: 2024-06-25 10:00:02 UTC

=== debian/changelog ===
r-cran-nloptr (2.1.1-1) unstable; urgency=medium

  * New upstream release
  
  * debian/control: Set Build-Depends: to current R version
  * debian/control: Set Standards-Version: to current version  
  * debian/control: Switch to virtual debhelper-compat (= 13)

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 08 Jul 2024 01:08:32 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: gnu-r
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper-compat (= 11), r-base-dev (>= 4.2.0), dh-r, libnlopt-dev, pkg-config, r-cran-testthat
-Standards-Version: 4.6.1
+Build-Depends: debhelper-compat (= 13), r-base-dev (>= 4.4.1), dh-r, libnlopt-dev, pkg-config, r-cran-testthat
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/edd/r-cran-nloptr
 Vcs-Git: https://salsa.debian.org/edd/r-cran-nloptr.git
 Homepage: https://cran.r-project.org/package=nloptr
